#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>

struct{char*name;double MW;}Elem[]={
  {"Ar", 39.948},
  {"Br", 79.904},
  {"C" , 12.011},
  {"Ca", 40.080},
  {"Cl", 35.453},
  {"F" , 18.998},
  {"H" ,  1.008},
  {"He",  4.003},
  {"I" ,126.905},
  {"Kr", 83.800},
  {"N" , 14.007},
  {"Na", 22.990},
  {"Ne", 20.179},
  {"O" , 15.999},
  {"S" , 32.060},
  {"Xe",131.300},
  {"Zn", 65.380},
  {NULL,  0.000}};

char*Comp[]={
  "CH3COCH3",
  "C2H2",
  "NH3",
  "BrCl",
  "Br2",
  "BrF",
  "BrO",
  "BrF3",
  "C4H10",
  "CaCO3",
  "CaO2H2",
  "CaO",
  "CaSO4",
  "CaS",
  "CaSO3",
  "CBr",
  "CCl",
  "CF2",
  "CN2",
  "CO2",
  "CF",
  "Cl2",
  "ClO2",
  "ClF",
  "ClO",
  "ClF5",
  "Cl2O",
  "ClF3",
  "CO",
  "CN",
  "CNBr",
  "CNCl",
  "CNI",
  "COBr2",
  "COCl2",
  "COF2",
  "COS",
  "CS",
  "C4N2",
  "C3O2",
  "HCN",
  "CNCN",
  "C6H2",
  "C2H6",
  "C2H5OH",
  "C2H4",
  "F2",
  "F2O",
  "FNO3",
  "HBr",
  "HCl",
  "H2",
  "C7H16",
  "C6H14",
  "HF",
  "H2S",
  "HO",
  "IBr",
  "ICl",
  "I2",
  "IF",
  "IF7",
  "IO",
  "IF5",
  "C4H10",
  "C5H12",
  "CH3COC2H5",
  "CH4",
  "CH3OH",
  "N2",
  "NO2",
  "N2O",
  "NO",
  "N2O2",
  "N2O5",
  "N2O4",
  "N2O3",
  "NO3",
  "C8H18",
  "O2",
  "O3",
  "C5H12",
  "C3H8",
  "SO2",
  "SO",
  "SO3",
  "H2SO4",
  "H2O",
  "ZnO",
  "ZnSO4",
  "ZnS",
  NULL};

double Weight(char*comp)
  {
  int i,j,k,l,m;
  double W;
  for(W=i=0;comp[i];i++)
    {
    if('a'<=comp[i+1]&&comp[i+1]<='z')
      {
      k=2;
      for(j=0;Elem[j].name;j++)
        if(strlen(Elem[j].name)==2)
          if(Elem[j].name[0]==comp[i])
            if(Elem[j].name[1]==comp[i+1])
              break;
      }
    else
      {
      k=1;
      for(j=0;Elem[j].name;j++)
        if(strlen(Elem[j].name)==1)
          if(Elem[j].name[0]==comp[i])
            break;
      }
    if(Elem[j].name==NULL)
      {
      printf("can't find %s\n",comp+i);
      exit(1);
      }
    l=0;
    while('0'<=comp[i+k+l]&&comp[i+k+l]<='9')
      l++;
    if(l>0)
      m=atoi(comp+i+k);
    else
      m=1;
    i+=k-1+l;
    W+=m*Elem[j].MW;
    }
  return(W);
  }

int main(int argc,char**argv,char**envp)
  {
  int i;
  for(i=0;Comp[i];i++)
    printf("%s,%.3lf\n",Comp[i],Weight(Comp[i]));
  return(0);
  }
